! Copyright (c) 1999-2002 by Sand & Associates

   OMIT('_EndOfInclude_',_SaTziIncluded_)           !Ensure that this is only included once.
_SaTziIncluded_  EQUATE(1)


TZI_SUCCESS         EQUATE(0)
TZI_NOTRANSITION    EQUATE(-1)


SYSTEMTIME      GROUP,TYPE
wYear            USHORT
wMonth           USHORT
wDayOfWeek       USHORT
wDay             USHORT
wHour            USHORT
wMinute          USHORT
wSecond          USHORT
wMilliseconds    USHORT
                END

TIME_ZONE_INFORMATION   GROUP,TYPE
Bias                     LONG
StandardName             CSTRING(64)
StandardDate             LIKE(SYSTEMTIME)   
StandardBias             LONG
DaylightName             CSTRING(64)
DaylightDate             LIKE(SYSTEMTIME)
DaylightBias             LONG
                        END

TIME_ZONE_ID_INVALID    EQUATE(0FFFFFFFFh)
TIME_ZONE_ID_UNKNOWN    EQUATE(0)
TIME_ZONE_ID_STANDARD   EQUATE(1)
TIME_ZONE_ID_DAYLIGHT   EQUATE(2)

!       MBCS and Unicode Translation Flags.
MB_PRECOMPOSED          EQUATE(01h)         ! use precomposed chars
MB_COMPOSITE            EQUATE(02h)         ! use composite chars
MB_USEGLYPHCHARS        EQUATE(04h)         ! use glyph chars, not ctrl chars
MB_ERR_INVALID_CHARS    EQUATE(08h)         ! error for invalid chars

WC_NULL                 EQUATE(0)
WC_NONE                 EQUATE(0)
WC_COMPOSITECHECK       EQUATE(200h)        ! convert composite to precomposed
WC_DISCARDNS            EQUATE(10h)         ! discard non-spacing chars
WC_SEPCHARS             EQUATE(20h)         ! generate separate chars
WC_DEFAULTCHAR          EQUATE(40h)         ! replace w/ default char

CP_ACP                  EQUATE(0)           ! Code page ANSI


!=========================================================================================
SaTziClass  CLASS,TYPE,MODULE('SaTzi.clw'),LINK('SaTzi.clw',1)

Tzi                     LIKE(TIME_ZONE_INFORMATION),AUTO
TziReturn               LONG,AUTO,PROTECTED
ActiveTimeBias          LONG,AUTO           !Current bias to UTC

StandardZoneName        CSTRING(65),AUTO
DaylightZoneName        CSTRING(65),AUTO
CurrentZoneName         CSTRING(65),AUTO    !Active time zone name

StandardStartDateStr    CSTRING(41),AUTO    !Date or Day in week
DaylightStartDateStr    CSTRING(41),AUTO    !

tzYear                  LONG                !Year to use for date calculations
StandardStartDate       LONG,AUTO           !Clarion Standard Date
DaylightStartDate       LONG,AUTO           !

StandardStartTime       LONG,AUTO           !Clarion Standard Time
DaylightStartTime       LONG,AUTO           !

LastErrorCode           LONG,AUTO           !Last API errorcode from GetLastError()
DateFormat              CSTRING(11)         !Defaults to @D17

!------ Public ---------------------------------------------------------------------
GetTimeZoneInfo         PROCEDURE(),LONG
SystemTimeToClarionTime PROCEDURE(*SYSTEMTIME st),LONG  
LocalTimeToUTC          PROCEDURE(LONG LocalTime),LONG  !Clarian standard time format
UTCToLocalTime          PROCEDURE(LONG UTC),LONG        !Clarion standard time format

!------ Private --------------------------------------------------------------------
GetStartDate            PROCEDURE(*CSTRING DateStr, *SYSTEMTIME st),PROTECTED
GetStartDate            PROCEDURE(*SYSTEMTIME st),LONG,PROTECTED  !Returns Clarion Standard date
GetStartTime            PROCEDURE(*SYSTEMTIME st),LONG,PROTECTED
DayInMonthToClarionDate PROCEDURE(LONG xYear, *SYSTEMTIME st),LONG,PROTECTED
W2A                     PROCEDURE(LONG lpWideString, *CSTRING lpANSIString),LONG,PROTECTED  !Wide to ANSI
            END


!_EndOfInclude_